# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, constr

class Alias(BaseModel):
    """
    Alias
    """
    attribute_name: constr(strict=True, max_length=576, min_length=0) = Field(..., alias="attributeName", description="The property key, identifier type, or field to be replaced by an alias.")
    attribute_alias: constr(strict=True, max_length=128, min_length=0) = Field(..., alias="attributeAlias", description="The alias to replace tPrecedencehe property key, identifier type, or field on the bound entity.")
    __properties = ["attributeName", "attributeAlias"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Alias:
        """Create an instance of Alias from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Alias:
        """Create an instance of Alias from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Alias.parse_obj(obj)

        _obj = Alias.parse_obj({
            "attribute_name": obj.get("attributeName"),
            "attribute_alias": obj.get("attributeAlias")
        })
        return _obj
